var win = $.win;

function doOnClose(e)
{
	
}

function doClose(e)
{
	
}

$.apiname = 'channels';

function doRefresh()
{
	Alloy.Globals.ws[$.apiname].get(
	function(loader, response)
	{
		if (Alloy.Globals.ws.responseutil.verify(response))
		{
			// update menu options
		}
	}
	);
}

function doOnOpen(e)
{
	doShowActionBar(tabGroup, false);
	createSideMenu();
	doRefresh();
}

function goHome()
{
	
}

var evtHandlers =
{
	doLogout:
		function(e)
		{
		},
	doGoHome:
		function(e)
		{
			goHome();
		}
};

function handleMenuEvent(e, name)
{
	Ti.API.info('handleMenuEvent(' + name + ')');
	if (name.charAt(0) == '#')
	{
		var handlerName = name.substring(1);
		evtHandlers[handlerName](e);
	}
	else if (name != '')
	{
		goHome();
		/*
	  	setTimeout(function()
		{
			doOpenWindow(name, function(controller, win)
			{
				if ('initialize' in controller)
					controller.initialize();
			});
		}, 250);
		*/
	}
}

Alloy.Globals.SliderDrawer =
{
	enabled: false,
	EnabledIconColor: Alloy.Globals.appconfig.hiliteColor,
	DisabledIconColor: 'lightgray',
	ListFontSize: 16,
	LineHeight: 34,
	ListItemSize: 24,
	Center: { y: 17 },
	Width: 200,
	TextColor: 'white',
	BackgroundColor: 'transparent',
	Profile: {
		ImageSize: 96,
		NameFontSize: 12
	},
	BackgroundGradient: Alloy.Globals.appconfig.menuGradient
};

function putTextProperties(item, bindId)
{
	if (bindId in item)
		putIfAbsent(item[bindId], 'color', Alloy.Globals.SliderDrawer.TextColor);
}

function AddToSlideDrawerMenu(menuItems, item)
{
	putIfAbsent(item, 'template', 'noBottom');

	putIfAbsent(item, 'properties', {});
	putIfAbsent(item.properties, 'height', Alloy.Globals.SliderDrawer.LineHeight);
	putIfAbsent(item.properties, 'backgroundColor', Alloy.Globals.SliderDrawer.BackgroundColor);
	putIfAbsent(item.properties, 'accessoryType', Ti.UI.LIST_ACCESSORY_TYPE_NONE);

	putTextProperties(item, 'option');
	putTextProperties(item, 'iconTop');
	putTextProperties(item, 'iconBottom');

	var s = JSON.stringify(item);
	Ti.API.info('menuItems.push(' + s + ');');
	menuItems.push(item);
}

var sideview = null;
var sideshow = false;
function createSideMenu()
{
	Ti.API.info('createSideMenu');
	var controller = Alloy.createController('sliderdrawer');
	var bgViewProps =
	{
  		top: 0,
  		left: 0,
  		width: Alloy.Globals.SliderDrawer.Width,
  		backgroundColor: 'black',
  		opacity: 0.8
  	};
  	var listViewProps =
	{
		top: 0,
  		left: 0,
  		width: Alloy.Globals.SliderDrawer.Width,
  		separatorColor: '#80555555'
	};
  	sideview = controller.backgroundView;
	Ti.API.info('backgroundView(' + sideview + ')');
  	win.add(sideview);
  	sideshow = true;
  	controller.initview(menuItems, bgViewProps, listViewProps, Alloy.Globals.SliderDrawer.Width, false, handleMenuEvent);
}

var menuItems = [];
AddToSlideDrawerMenu(menuItems, { eventname: '#doLogout', iconTop: {text: '\uf26c'}, option: {text: 'Channel'} });
AddToSlideDrawerMenu(menuItems, { eventname: '#doGoHome', iconTop: {text: '\uf008'}, option: {text: 'Episode'} });

function doMenuButton(e)
{
	Ti.API.info('doMenuButton(' + JSON.stringify(e) + ')');
	sideshow = !sideshow;
	if (sideshow)
		sideview.show();
	else
		sideview.hide();
}

var tab = $.tab;
Alloy.Globals.tab = tab;
var tabGroup = $.tabGroup;
Alloy.Globals.tabGroup = tabGroup;

var tabs = [tab];
tabGroup.setTabs(tabs);

Ti.API.info('Alloy.Globals.appstate test(' + JSON.stringify(Alloy.Globals.appstate) + ')');
if (Alloy.Globals.appstate.loggedin)
{
	Ti.API.info('index.js($.tabGroup.open();)');
	$.tabGroup.open();
}
else
{
	Ti.API.info('index.js(Alloy.Globals.ws.auth.login)');
	Alloy.Globals.ws.auth.login(
	function(loader, response)
	{
		Ti.API.info('index.js(if (Alloy.Globals.ws.responseutil.verify(response))');
		if (Alloy.Globals.ws.responseutil.verify(response))
		{
			Ti.API.info('index.js($.tabGroup.open();)');
			$.tabGroup.open();
		}
	}
	);
}

